<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>m17n ライブラリ: 構造体 MConverter</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- 作成： Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'検索');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>メインページ</span></a></li>
      <li><a href="pages.html"><span>関連ページ</span></a></li>
      <li><a href="modules.html"><span>モジュール</span></a></li>
      <li class="current"><a href="annotated.html"><span>データ構造</span></a></li>
      <li><a href="files.html"><span>ファイル</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="検索" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="annotated.html"><span>データ構造</span></a></li>
      <li><a href="classes.html"><span>データ構造索引</span></a></li>
      <li><a href="functions.html"><span>データフィールド</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>構造体 MConverter<br/>
<small>
[<a class="el" href="group__m17nConv.html">コード変換</a>]</small>
</h1><!-- doxytag: class="MConverter" -->
<p>コード変換に用いられる構造体.  
<a href="#_details">[詳細]</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>変数</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMConverter.html#a1e6ac361d7ec9fc7b8e6471641b8df05">lenient</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMConverter.html#a25e07110149579b8867e4795b280e868">last_block</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMConverter.html#a99e6c2a37b8f4313960b9006fcf3ddc2">at_most</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMConverter.html#a6b7c87d3ce21346ff6543e7afadab693">nchars</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMConverter.html#a70d38d3bda2a382e037fbe72f7e46be1">nbytes</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum <a class="el" href="group__m17nConv.html#gafef05a0f12fd162f58fb750a2f1fbec7">MConversionResult</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMConverter.html#a10d13721702b68bfa1ecf16a877dd640">result</a></td></tr>
<tr><td class="memItemLeft" >union {</td></tr>
<tr><td class="memItemLeft" >&nbsp;&nbsp;&nbsp;void *&nbsp;&nbsp;&nbsp;<a class="el" href="structMConverter.html#ad5b2106ccda2ff7146717234462f3653">ptr</a></td></tr>
<tr><td class="memItemLeft" >&nbsp;&nbsp;&nbsp;double&nbsp;&nbsp;&nbsp;<a class="el" href="structMConverter.html#a32be6c26106bc428e5517d4b64b8e5cf">dbl</a></td></tr>
<tr><td class="memItemLeft" >&nbsp;&nbsp;&nbsp;char&nbsp;&nbsp;&nbsp;<a class="el" href="structMConverter.html#ad88907a7a365905704cf01f5da5b7a59">c</a> [256]</td></tr>
<tr><td class="memItemLeft" valign="top">}&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMConverter.html#a6900c286637b8bd870c4357b9cdc9d33">status</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMConverter.html#a0316d9ad5f6ea12f166b4db59dc5ab3d">internal_info</a></td></tr>
</table>
<hr/><a name="_details"></a><h2>説明</h2>
<p>コード変換に用いられる構造体. </p>
<p>コード変換に用いられる構造体。最初の３つのメンバは変換を制御する。</p>
 <hr/><h2>構造体</h2>
<a class="anchor" id="a1e6ac361d7ec9fc7b8e6471641b8df05"></a><!-- doxytag: member="MConverter::lenient" ref="a1e6ac361d7ec9fc7b8e6471641b8df05" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMConverter.html#a1e6ac361d7ec9fc7b8e6471641b8df05">MConverter::lenient</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>厳密な変換が必要でない場合に値を 0 以外にする。 デフォルトでは、変換は厳密である。</p>
<p>変換が厳密とは、デコードの際には最初の不正なバイトでコンバータが止まること、 エンコードの際には変換されるコード系でサポートされない最初の文字でコンバータが止まることを指す。 これらの場合、<code>MConverter-&gt;result</code> はそれぞれ <code>MCONVERSION_RESULT_INVALID_BYTE</code> か<code>MCONVERSION_RESULT_INVALID_CHAR</code> となる。</p>
<p>変換が厳密でない場合には、デコードの際の不正なバイトはそのバイトのまま残る。 またエンコードの際には、不正な文字が Unicode 文字の場合には "&lt;U+XXXX&gt;" に、そうでない場合には "&lt;M+XXXXXX&gt;" に置き換えられる。 </p>

</div>
</div>
<a class="anchor" id="a25e07110149579b8867e4795b280e868"></a><!-- doxytag: member="MConverter::last_block" ref="a25e07110149579b8867e4795b280e868" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMConverter.html#a25e07110149579b8867e4795b280e868">MConverter::last_block</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>バイト列の終端のブロックをデコードする際、または文字列の終端のブロックをエンコードする際は、値を 0 以外にする。この値は以下のように変換に影響する。</p>
<p>デコーディングの際に最後の数バイトが正しいバイトシークエンスを形成するには短すぎる場合：</p>
<p>値が 0 でなければ、変換はそのシークエンスの最初のバイトにおいて、エラー (MCONVERSION_RESULT_INVALID_BYTE) で終る。</p>
<p>値が 0 ならば、変換は成功して終る。 問題の数バイトはキャリーオーバとしてコンバータに保持され、変換の続きを行う際に変換するバイト列の前に付けられる。</p>
<p>エンコーディングの際にコード系が文脈依存の場合、</p>
<p>値が 0 でなければ、コンテキストを最初に戻すためのバイト列がソースの文字とかかわりなく変換の結果生成されることがある。</p>
<p>値が 0 ならば、そのようなバイト列は生成されない。 </p>

</div>
</div>
<a class="anchor" id="a99e6c2a37b8f4313960b9006fcf3ddc2"></a><!-- doxytag: member="MConverter::at_most" ref="a99e6c2a37b8f4313960b9006fcf3ddc2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned <a class="el" href="structMConverter.html#a99e6c2a37b8f4313960b9006fcf3ddc2">MConverter::at_most</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>0 でなければ、変換される最大の文字数を指定する。 </p>

</div>
</div>
<a class="anchor" id="a6b7c87d3ce21346ff6543e7afadab693"></a><!-- doxytag: member="MConverter::nchars" ref="a6b7c87d3ce21346ff6543e7afadab693" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMConverter.html#a6b7c87d3ce21346ff6543e7afadab693">MConverter::nchars</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>以下の３つのメンバは変換の結果を表すためのものである。</p>
<p>最近にデコード/エンコードされた文字数。 </p>

</div>
</div>
<a class="anchor" id="a70d38d3bda2a382e037fbe72f7e46be1"></a><!-- doxytag: member="MConverter::nbytes" ref="a70d38d3bda2a382e037fbe72f7e46be1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMConverter.html#a70d38d3bda2a382e037fbe72f7e46be1">MConverter::nbytes</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>最近にデコード/エンコードされたバイト数。 </p>

</div>
</div>
<a class="anchor" id="a10d13721702b68bfa1ecf16a877dd640"></a><!-- doxytag: member="MConverter::result" ref="a10d13721702b68bfa1ecf16a877dd640" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="group__m17nConv.html#gafef05a0f12fd162f58fb750a2f1fbec7">MConversionResult</a> <a class="el" href="structMConverter.html#a10d13721702b68bfa1ecf16a877dd640">MConverter::result</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>コード変換の結果を示すコード。 </p>

</div>
</div>
<a class="anchor" id="ad5b2106ccda2ff7146717234462f3653"></a><!-- doxytag: member="MConverter::ptr" ref="ad5b2106ccda2ff7146717234462f3653" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="structMConverter.html#ad5b2106ccda2ff7146717234462f3653">MConverter::ptr</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a32be6c26106bc428e5517d4b64b8e5cf"></a><!-- doxytag: member="MConverter::dbl" ref="a32be6c26106bc428e5517d4b64b8e5cf" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double <a class="el" href="structMConverter.html#a32be6c26106bc428e5517d4b64b8e5cf">MConverter::dbl</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ad88907a7a365905704cf01f5da5b7a59"></a><!-- doxytag: member="MConverter::c" ref="ad88907a7a365905704cf01f5da5b7a59" args="[256]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char <a class="el" href="structMConverter.html#ad88907a7a365905704cf01f5da5b7a59">MConverter::c</a>[256]</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a6900c286637b8bd870c4357b9cdc9d33"></a><!-- doxytag: member="MConverter::status" ref="a6900c286637b8bd870c4357b9cdc9d33" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">union { ... }   <a class="el" href="structMConverter.html#a6900c286637b8bd870c4357b9cdc9d33">MConverter::status</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>コード変換の状況に関する種々の情報。内容はコード系のタイプによって異なる。 <code>status</code> はどのような型へのキャストに対しても安全なようにメモリアラインされており、また最低256バイトのメモリ領域が使えるようになっている。 </p>

</div>
</div>
<a class="anchor" id="a0316d9ad5f6ea12f166b4db59dc5ab3d"></a><!-- doxytag: member="MConverter::internal_info" ref="a0316d9ad5f6ea12f166b4db59dc5ab3d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="structMConverter.html#a0316d9ad5f6ea12f166b4db59dc5ab3d">MConverter::internal_info</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>このメンバは内部的に使用され、アプリケーションプログラムは触れてはならない。 </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>全て</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>データ構造</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>ファイル</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>関数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>変数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>型定義</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>列挙型</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>列挙型の値</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>マクロ定義</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<!-- -*- coding: utf-8; -*- -->
<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-ja/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
